// ObjectWindows - (C) Copyright 1991 by Borland International

/* --------------------------------------------------------
  BROWWND.CPP
  Defines type TBrowserWindow, a text browser
  -------------------------------------------------------- */

#define WIN30
#include <owl.h>
#include "listbox.h"
#include "browwnd.h"

/* Constructor for a TBrowserWindow.  Initializes its data fields using
   passed parameters and default values.  Constructs its child edit
   control. */
TBrowserWindow::TBrowserWindow(PTWindowsObject AParent, LPSTR ATitle,
			 PTModule AModule)
	    : TWindow(AParent, ATitle, AModule)
{
  Browser = new TListBox(this, 0, 0, 0, 0, 0, GetModule());
  Browser->Attr.Style &= ~LBS_STANDARD;
  Browser->Attr.Style |= WS_VSCROLL | LBS_NOTIFY;
}

// Adds an item to the associated list box and sets the
// selection to the end of the box
void TBrowserWindow::AddString( LPSTR AString )
{
  Browser->AddString( AString );
  Browser->SetSelIndex( Browser->GetCount() - 1 );
}

/* Responds to an incoming WM_SIZE message by resizing the child edit
  control according to the size of the TEditWindow's client area. */
void TBrowserWindow::WMSize(RTMessage Msg)
{
  TWindow::WMSize(Msg);
  SetWindowPos(Browser->HWindow, 0, -1, -1, LOWORD(Msg.LParam)+2,
    HIWORD(Msg.LParam)+2, SWP_NOZORDER);
}

/* Responds to an incoming WM_SETFOCUS message by setting the focus to
   the child edit control. */
void TBrowserWindow::WMSetFocus(RTMessage)
{
  SetFocus(Browser->HWindow);
}
