/************ raflist.cpp
		Implements limited list capability for
		the Rafael framework
		Written by Gabor Paller
					*************/

#include	<alloc.h>
#include	"raflist.h"

// SchedListObject. Implements a list of another lists. Basic node
// element

// SchedListObject default constructor
SchedListObject::SchedListObject()
{
  Node = 0;
  Data1 = 0L;
  Data2 = 0L;
  Node2 = 0;
  Data3 = 0L;
  Data4 = 0L;
  BackLink = NULL;
  ForwLink = NULL;
  SubList = NULL;
  ListHead = NULL;
}

// Constructor. Gets the node number
SchedListObject::SchedListObject( NODETYPE node,unsigned long data1,
				       unsigned long data2,NODETYPE node2,
				       unsigned long data3,unsigned long data4 )
{
  Node = node;
  Data1 = data1;
  Data2 = data2;
  Node2 = node2;
  Data3 = data3;
  Data4 = data4;
  BackLink = NULL;
  ForwLink = NULL;
  SubList = NULL;
  ListHead = NULL;
}

// Inserts one element into the sublist. Gets the node to
// be inserted
void SchedListObject::Insert( PtSchedListObject NewObject )
{
  if( SubList != NULL )
	SubList->ForwLink = NewObject;
  NewObject->BackLink = SubList;
  NewObject->ForwLink = NULL;
  SubList = NewObject;
  if( ListHead == NULL )
	ListHead = NewObject;
}

// Removes an element from the subview list. Gets pointer
// to the element to be removed
void SchedListObject::Remove( PtSchedListObject OldObject )
{
  if( OldObject->BackLink != NULL )
    OldObject->BackLink->ForwLink = OldObject->ForwLink;
  if( OldObject->ForwLink != NULL )
    OldObject->ForwLink->BackLink = OldObject->BackLink;
  if( SubList == OldObject )
	SubList = OldObject->BackLink;
  if( ListHead == OldObject )
		ListHead = OldObject->ForwLink;
}

// Searches a given node in the sublist. Gets the node number,
// returns a pointer to the node found or NULL.
PtSchedListObject SchedListObject::Search( NODETYPE snode )
{
  PtSchedListObject	p;

  p = SubList;
  while( p != NULL )
	if( p->Node == snode )
		break;
	else
	  p = p->BackLink;
  return p;
}

// Deletes all sublist nodes of the list element
void SchedListObject::DeleteSubList()
{
  PtSchedListObject	p;
  PtSchedListObject	p1;

  p = SubList;
  while( p != NULL )
  {
    if( p->SubList != NULL )
	p->DeleteSubList();
    p1 = p;
    p = p->BackLink;
    delete p1;
  }
  SubList = NULL;
}
