/******** rc3.cpp
		Rafael compiler,part 3
		Written by Gabor Paller
				******/

#include	<windows.h>
#include	<stdio.h>
#include	<ctype.h>
#include	<string.h>
#include	"robject.h"
#include	"rcomp.h"
#include	"xserver.h"
#include	"rci.h"

extern Processor	ProcessorList;
extern INPUTTYPE	MaxProbeNum;
extern BOOL		IsDynamic;

// Message file
extern FILE		*MsgFile;
// Line counter
extern unsigned long	LineCtr;
// Error counter
extern unsigned ErrCtr;
// Warning counter
extern unsigned WarnCtr;
// Handle of the main window
extern HWND MainWindow;
// Handle of the comm window
extern HWND CommWindow;
// Actual block pointer
extern PtBlock	ActBlock;
// Rootblock object
extern Block	RootBlock;

// work string variable
extern char work[1024];
// work string variable 2
extern char work1[140];
// work string variable 3
extern char work2[1024];

// Stores the EQU statement
char	equstr[128];

// UpScale and DownScale limit values from RC1
extern unsigned LUpScale,LDownScale;

// Stores the remark character
char	remstr[32];

// Output file pointer
FILE	*OutFile;
// Schedule file output
FILE	*SchedFile;
// **** Debugging file ****
FILE	*DebFile;
// **** Debugging file : channel sharing ****
FILE	*ChanFile;

// Loop head, counter and ID
PtActivity	LoopHead;
unsigned	LoopCount;
unsigned long	LoopID;

// Output line
char	OutLine[1024];

// Imported functions from RCOMP.CPP
void SendMessageLine( char * );
void UpdateDlgText( int,char * );
LPSTR DRCIExecuteCommand( HWND,LPSTR );

// Imported functions from RC1.CPP
void WarningMessage( char[] );

// Mangles the parameter string by substituting
// \n by 0x0A and \t by 0x09 characters
void Mangle( char string[] )
{
  char	*sp,*dp,ch;

  sp = dp = string;
  while( *sp != 0 )
  {
    if( ( ch = *sp ) == '\\' )
      switch( *(sp+1) )
      {
	case 'n':
		ch = 0x0A;
		++sp;
		break;
	case 't':
		ch = 0x09;
		++sp;
		break;
      }
    *( dp++ ) = ch;
    ++sp;
  }
  *dp = 0;
}

// Asks line-by-line the contents of the outtext
// variable from XLisp and writes it into the
// output file
void DispatchOutput()
{
  do
  {
    wsprintf( work,"(return-code)\n" );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    if( work[1] != '"' )	// If not empty string
    {
      work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
      sprintf( OutLine,work+1 );
      Mangle( OutLine );
      fputs( OutLine,OutFile );
    }
    else
	break;			// break cycle
  }
  while( TRUE );
}

// Sends out the constructor section. Gets the processor
// number whose constructor section should be generated
void GenerateConstructorSection( PtProcessor PProc,
				int ProcNum )
{
  PtActivity	p1,PAct;
  PtNodeInfo	ip;
  PtNodeObject	np,Parent;
  int		i,Inpnum,Outnum;
  char		temp[30];
  unsigned long	VID;

  PAct = (PtActivity)(ActBlock->ActivityList).Search( ProcNum );
  p1 = (PtActivity)PAct->ListHead;
  while( p1 != NULL )
  {
    switch( p1->ActId )
    {
    case ACT_OPERATOR:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_ALL );
      Inpnum = ip->Inputs;
      Outnum = ip->Outputs;

// Creating input list
      strcpy( work1,"" );
      for( i = 1 ; i <= Inpnum ; ++i )
      {
	np = (ip->GraphPtr)->Search( i,NOT_VALID );
	if( np != NULL )
	{
	  if( ( Parent = np->UpNode ) == NULL )
		Parent = np;
	  sprintf( temp,"var%lu ",Parent->NodeVariable->ID );
	  strcat( work1,temp );
	}
      }

// Creating output list
      strcpy( work2,"" );
      for( i = 1 ; i <= Outnum ; ++i )
      {
	np = (ip->GraphPtr)->Search( NOT_VALID,i );
	if( np != NULL )
	{
	  sprintf( temp,"var%lu ",np->NodeVariable->ID );
	  strcat( work2,temp );
	}
      }

      wsprintf( work,"(get-constr %s '%s '%s%u '(%s) '(%s))\n",
		(LPSTR)ip->Operator,(LPSTR)PProc->Device,
		(LPSTR)ActBlock->BlockName,p1->NodeNum,
		(LPSTR)work1,(LPSTR)work2 );
      _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
      XDDeleteReply( CommWindow );
      if( strncmp( work,"1",1 ) == 0 )
      {
	sprintf( OutLine,"\n%sConstructor for node %u\n",
			remstr,p1->NodeNum );
	fputs( OutLine,OutFile );
	DispatchOutput();
      }
      break;

    case ACT_GETDELAY:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_OUT );
      np = (ip->GraphPtr)->Search( NOT_VALID,1 );
      VID = np->NodeVariable->ID;
      wsprintf( work,"(get-constr DELAY '%s '%s%u '() '(var%lu))\n",
		(LPSTR)PProc->Device,
		(LPSTR)ActBlock->BlockName,
		p1->NodeNum,
		VID );
      _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
      XDDeleteReply( CommWindow );
      if( strncmp( work,"1",1 ) == 0 )
      {
	sprintf( OutLine,"\n%sConstructor for delay output %u\n",
			remstr,p1->NodeNum );
	fputs( OutLine,OutFile );
	DispatchOutput();
      }
      break;

    case ACT_PUTDELAY:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_IN );
      np = (ip->GraphPtr)->Search( 1,NOT_VALID );
      if( ( Parent = np->UpNode ) == NULL )
		Parent = np;
      VID = Parent->NodeVariable->ID;
      wsprintf( work,"(get-constr DELAY '%s '%s%u '(var%lu) '())\n",
		(LPSTR)PProc->Device,
		(LPSTR)ActBlock->BlockName,
		p1->NodeNum,
		VID );
      _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
      XDDeleteReply( CommWindow );
      if( strncmp( work,"1",1 ) == 0 )
      {
	sprintf( OutLine,"\n%sConstructor for delay input %u\n",
			remstr,p1->NodeNum );
	fputs( OutLine,OutFile );
	DispatchOutput();
      }
      break;

    }		// switch
    p1 = (PtActivity)p1->ForwLink;
  }
}

// Sends out the operator section. Gets the processor
// number.
void GenerateOperatorSection( PtProcessor PProc,
				int ProcNum )
{
  PtActivity	p1,PAct;
  PtProcessor	TProc;
  PtNodeInfo	ip;
  PtNodeObject	np,Parent;
  int		i,Inpnum,Outnum;
  char		temp[30];
  unsigned long	VID,utmp;
  PtChannel	CP,NCP;

  LoopHead = NULL;
  LoopCount = 0;
  LoopID = 0L;

  PAct = (PtActivity)(ActBlock->ActivityList).Search( ProcNum );
  p1 = (PtActivity)PAct->ListHead;
  while( p1 != NULL )
  {
//**// Debugging code !!

    ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_ALL );
    fprintf( DebFile,"Node %u, ASAP %lu, ALAP %lu\n",
	     ip->NodeNum,ip->ASAP,ip->ALAP );

//**// End of debugging code

    switch( p1->ActId )
    {
    case ACT_INPPROBE:
    case ACT_OUTPROBE:
    case ACT_OPERATOR:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_ALL );
      sprintf( OutLine,"\n%sNode %u,scheduled at %lu\n",remstr,p1->NodeNum,p1->STime );
      fputs( OutLine,OutFile );
      Inpnum = ip->Inputs;
      Outnum = ip->Outputs;

// Creating input list
      strcpy( work1,"" );
      for( i = 1 ; i <= Inpnum ; ++i )
      {
	np = (ip->GraphPtr)->Search( i,NOT_VALID );
	if( np != NULL )
	{
	  if( ( Parent = np->UpNode ) == NULL )
			Parent = np;
	  sprintf( temp,"var%lu ",Parent->NodeVariable->ID );
	  strcat( work1,temp );
	}
      }

// Creating output list
      strcpy( work2,"" );
      for( i = 1 ; i <= Outnum ; ++i )
      {
	np = (ip->GraphPtr)->Search( NOT_VALID,i );
	if( np != NULL )
	{
	  sprintf( temp,"var%lu ",np->NodeVariable->ID );
	  strcat( work2,temp );
	}
      }

      wsprintf( work,"(get-input-code %s '%s '%s%u '(%s) '(%s))\n",
	      (LPSTR)ip->Operator,(LPSTR)PProc->Device,
	      (LPSTR)ActBlock->BlockName,
	      p1->NodeNum,(LPSTR)work1,(LPSTR)work2 );
      DRCIExecuteCommand( CommWindow, work );
      XDDeleteReply( CommWindow );
      DispatchOutput();
      break;

    case ACT_GETDELAY:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_OUT );
      sprintf( OutLine,"\n%sDelay output %u,scheduled at %lu\n",remstr,p1->NodeNum,p1->STime );
      fputs( OutLine,OutFile );
      np = (ip->GraphPtr)->Search( NOT_VALID,1 );
      VID = np->NodeVariable->ID;
      wsprintf( work,"(get-input-code DELAY '%s '%s%u '() '(var%lu))\n",
		(LPSTR)PProc->Device,
		(LPSTR)ActBlock->BlockName,
		p1->NodeNum,
		VID );
      DRCIExecuteCommand( CommWindow, work );
      XDDeleteReply( CommWindow );
      DispatchOutput();
      break;

    case ACT_PUTDELAY:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_IN );
      sprintf( OutLine,"\n%sDelay input %u,scheduled at %lu\n",remstr,p1->NodeNum,p1->STime );
      fputs( OutLine,OutFile );
      np = (ip->GraphPtr)->Search( 1,NOT_VALID );
      if( ( Parent = np->UpNode ) == NULL )
		Parent = np;
      VID = Parent->NodeVariable->ID;
      wsprintf( work,"(get-input-code DELAY '%s '%s%u '(var%lu) '())\n",
		(LPSTR)PProc->Device,
		(LPSTR)ActBlock->BlockName,
		p1->NodeNum,
		VID );
      DRCIExecuteCommand( CommWindow, work );
      XDDeleteReply( CommWindow );
      DispatchOutput();
      break;

    case ACT_SEND:		// Send activity
      sprintf( OutLine,"\n%sSending to proc#%u at %lu\n",
			remstr,p1->Aux,p1->STime );
      fputs( OutLine,OutFile );
      TProc = (PtProcessor)ProcessorList.Search( p1->Aux );
      wsprintf( work,"(send-var %u '%s %u '%s 'var%lu %lu)\n",
		PProc->NodeNum,
		(LPSTR)PProc->Device,
		TProc->NodeNum,
		(LPSTR)TProc->Device,
		(p1->VarField)->ID,
		(p1->VarField)->Size
		);
      DRCIExecuteCommand( CommWindow, work );
      XDDeleteReply( CommWindow );
      DispatchOutput();
      break;

    case ACT_RECEIVE:	// Receive activity
      sprintf( OutLine,"\n%sReceiving from proc#%u at %lu\n",
			remstr,p1->Aux,p1->STime );
      fputs( OutLine,OutFile );
      TProc = (PtProcessor)ProcessorList.Search( p1->Aux );
      wsprintf( work,"(rec-var %u '%s %u '%s 'var%lu %lu)\n",
		TProc->NodeNum,
		(LPSTR)TProc->Device,
		PProc->NodeNum,
		(LPSTR)PProc->Device,
		(p1->VarField)->ID,
		(p1->VarField)->Size
		);
      DRCIExecuteCommand( CommWindow, work );
      XDDeleteReply( CommWindow );
      DispatchOutput();
      break;

    case ACT_SAMPLERATE:
      if( LoopHead != NULL )
      {
	wsprintf( work,"(get-loop-end '%s %lu)\n",
			  (LPSTR)PProc->Device,LoopID++ );
	_fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
	XDDeleteReply( CommWindow );
	if( *(work+1) == '"' )	// if the answer is empty string
	{
	  if( --LoopCount != 0 )
	  {
	    p1 = LoopHead;
	    break;
	  }
	}
	else
	{
	  work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
	  Mangle( work+1 );
	  fputs( work+1,OutFile );
	}
	LoopHead = NULL;
      }
      utmp = ( p1->UpScale * LDownScale ) / ( p1->DownScale * LUpScale );
      if( utmp != 1L )
      {
	wsprintf( work,"(get-loop-head '%s %lu %lu)\n",
			  (LPSTR)PProc->Device,LoopID,utmp );
	_fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
	XDDeleteReply( CommWindow );
	work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
	Mangle( work+1 );
	fputs( work+1,OutFile );

// ForwLink because p1 points to the repeat activity !!!
	LoopHead = (PtActivity)p1->ForwLink;
	LoopCount = (unsigned)utmp;
      }
      break;

    }		// switch

// Appending to sched file - sent to the framework
    if( p1->ActId == ACT_SEND )
      fprintf( SchedFile,"P%u:N0,%lu,%lu;P%u,%lu,%lu\n",
		 PProc->NodeNum,p1->STime,p1->ExecTime,
		 p1->Aux,(p1->PartnerAct)->STime,
		 (p1->PartnerAct)->ExecTime );
    else
      fprintf( SchedFile,"P%u:N%u,%lu,%lu;P0,0,0\n",
		PProc->NodeNum,p1->NodeNum,p1->STime,p1->ExecTime );
    p1 = (PtActivity)p1->ForwLink;

// Finish scale loop if end of activity list and scale
// loop still active
    if( ( p1 == NULL ) && ( LoopHead != NULL ) )
    {
      wsprintf( work,"(get-loop-end '%s %lu)\n",
			(LPSTR)PProc->Device,LoopID++ );
      _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
      XDDeleteReply( CommWindow );
      if( *(work+1) == '"' )	// if the answer is empty string
      {
	if( --LoopCount != 0 )
	    p1 = LoopHead;
      }
      else
      {
	work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
	Mangle( work+1 );
	fputs( work+1,OutFile );
      }
      LoopHead = NULL;
    }
  }	// while

// Writing out channel activity
  if( ProcNum == 1 )
  {
    fprintf( ChanFile,"; Block %s\n",ActBlock->BlockName );
    CP = (PtChannel)(ActBlock->Channels).SubList;
    while( CP != NULL )
    {
      NCP = (PtChannel)CP->ListHead;
      while( NCP != NULL )
      {
	fprintf( ChanFile,"%u:SEND:%lu;%lu:REC:%lu;%lu\n",
	       CP->NodeNum,NCP->SendStartOccupied,
	       NCP->SendEndOccupied,NCP->RecStartOccupied,
	       NCP->RecEndOccupied );
	NCP = (PtChannel)NCP->ForwLink;
      }
      CP = (PtChannel)CP->BackLink;
    }
  }
}


// Sends out the destructor section. Gets the processor
// number whose destructor section should be generated
void GenerateDestructorSection( PtProcessor PProc,
				int ProcNum )
{
  PtActivity	p1,PAct;
  PtNodeInfo	ip;
  PtNodeObject	np,Parent;
  int		i,Inpnum,Outnum;
  char		temp[30];
  unsigned long	VID;

  PAct = (PtActivity)(ActBlock->ActivityList).Search( ProcNum );
  p1 = (PtActivity)PAct->ListHead;
  while( p1 != NULL )
  {
    switch( p1->ActId )
    {
    case ACT_OPERATOR:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_ALL );
      Inpnum = ip->Inputs;
      Outnum = ip->Outputs;

// Creating input list
      strcpy( work1,"" );
      for( i = 1 ; i <= Inpnum ; ++i )
      {
	np = (ip->GraphPtr)->Search( i,NOT_VALID );
	if( np != NULL )
	{
	  if( ( Parent = np->UpNode ) == NULL )
		Parent = np;
	  sprintf( temp,"var%lu ",Parent->NodeVariable->ID );
	  strcat( work1,temp );
	}
      }

// Creating output list
      strcpy( work2,"" );
      for( i = 1 ; i <= Outnum ; ++i )
      {
	np = (ip->GraphPtr)->Search( NOT_VALID,i );
	if( np != NULL )
	{
	  sprintf( temp,"var%lu ",np->NodeVariable->ID );
	  strcat( work2,temp );
	}
      }

      wsprintf( work,"(get-destr %s '%s '%s%u '(%s) '(%s))\n",
		(LPSTR)ip->Operator,(LPSTR)PProc->Device,
		(LPSTR)ActBlock->BlockName,
		p1->NodeNum,(LPSTR)work1,(LPSTR)work2 );
      _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
      XDDeleteReply( CommWindow );
      if( strncmp( work,"1",1 ) == 0 )
      {
	sprintf( OutLine,"\n%sDestructor for node %u\n",
			remstr,p1->NodeNum );
	fputs( OutLine,OutFile );
	DispatchOutput();
      }
      break;

    case ACT_GETDELAY:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_OUT );
      np = (ip->GraphPtr)->Search( NOT_VALID,1 );
      VID = np->NodeVariable->ID;
      wsprintf( work,"(get-destr DELAY '%s '%s%u '() '(var%lu))\n",
		(LPSTR)PProc->Device,
		(LPSTR)ActBlock->BlockName,
		p1->NodeNum,
		VID );
      _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
      XDDeleteReply( CommWindow );
      if( strncmp( work,"1",1 ) == 0 )
      {
	sprintf( OutLine,"\n%sDestructor for delay output %u\n",
			remstr,p1->NodeNum );
	fputs( OutLine,OutFile );
	DispatchOutput();
      }
      break;

    case ACT_PUTDELAY:
      ip = (PtNodeInfo)(ActBlock->NodeList).Search( p1->NodeNum,OPTYPE_IN );
      np = (ip->GraphPtr)->Search( 1,NOT_VALID );
      if( ( Parent = np->UpNode ) == NULL )
		Parent = np;
      VID = Parent->NodeVariable->ID;
      wsprintf( work,"(get-destr DELAY '%s '%s%u '(var%lu) '())\n",
		(LPSTR)PProc->Device,
		(LPSTR)ActBlock->BlockName,
		p1->NodeNum,
		VID );
      _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
      XDDeleteReply( CommWindow );
      if( strncmp( work,"1",1 ) == 0 )
      {
	sprintf( OutLine,"\n%sDestructor for delay input %u\n",
			remstr,p1->NodeNum );
	fputs( OutLine,OutFile );
	DispatchOutput();
      }
      break;

    }		// switch
    p1 = (PtActivity)p1->ForwLink;
  }
}

// Generates the dynamic scheduler section for the
// given processor. The upper level can contain only
// probes and blocks
int GenerateDynamicScheduler( PtProcessor PProc,
			      PtActivity PAct )
{
  PtActivity	ap;
  PtNodeInfo	ip;
  PtNodeObject	Parent,np;
  PtVariable	Var;
  int		Inpnum,Outnum,i;
  char		temp[30];

  wsprintf( work,"(get-begin-block '%s 'ROOT)\n",
		(LPSTR)PProc->Device );
  DRCIExecuteCommand( CommWindow, work );
  XDDeleteReply( CommWindow );
  DispatchOutput();

  ap = (PtActivity)PAct->ListHead;
  while( ap != NULL )
  {
    ip = (PtNodeInfo)(ActBlock->NodeList).Search( ap->NodeNum,OPTYPE_ALL );
    switch( ap->ActId )
    {
    case ACT_INPPROBE:
    case ACT_OUTPROBE:
	ip = (PtNodeInfo)(ActBlock->NodeList).Search( ap->NodeNum,OPTYPE_ALL );
	sprintf( OutLine,"\n%sProbe %u\n",remstr,ap->NodeNum );
	fputs( OutLine,OutFile );
	Inpnum = ip->Inputs;
	Outnum = ip->Outputs;

// Creating input list
	strcpy( work1,"" );
	for( i = 1 ; i <= Inpnum ; ++i )
	{
	  np = (ip->GraphPtr)->Search( i,NOT_VALID );
	  if( np != NULL )
	  {
	    if( ( Parent = np->UpNode ) == NULL )
			Parent = np;
	    Var = Parent->NodeVariable;
	    sprintf( temp,"var%lu ",Var->ID );
	    strcat( work1,temp );
	  }
	}

// Creating output list
	strcpy( work2,"" );
	for( i = 1 ; i <= Outnum ; ++i )
	{
	  np = (ip->GraphPtr)->Search( NOT_VALID,i );
	  if( np != NULL )
	  {
	    Var = np->NodeVariable;
	    sprintf( temp,"var%lu ",Var->ID );
	    strcat( work2,temp );
	  }
	}

	wsprintf( work,"(get-input-code %s '%s '%s%u '(%s) '(%s))\n",
	      (LPSTR)ip->Operator,(LPSTR)PProc->Device,
	      (LPSTR)ActBlock->BlockName,
	      ip->NodeNum,(LPSTR)work1,(LPSTR)work2 );
	DRCIExecuteCommand( CommWindow, work );
	XDDeleteReply( CommWindow );
	DispatchOutput();
	break;

    case ACT_BLOCK:
// Test if we have a control input
	np = (ip->GraphPtr)->Search( 0, NOT_VALID );
	Var = NULL;
	if( np != NULL )
	{
	  Parent = np->UpNode;
	  if( Parent != NULL )
		Var = Parent->NodeVariable;
	}
	if( Var == NULL )
		sprintf( temp,"NIL" );
	else
		sprintf( temp,"'var%lu",Var->ID );

	wsprintf( work,"(get-invoc-block '%s '%s %s)\n",
			(LPSTR)PProc->Device,
			(LPSTR)ip->Operator,
			(LPSTR)temp );
	DRCIExecuteCommand( CommWindow, work );
	XDDeleteReply( CommWindow );
	DispatchOutput();
	break;
    }
    ap = (PtActivity)ap->ForwLink;
  }

  wsprintf( work,"(get-end-block '%s 'ROOT)\n",
		(LPSTR)PProc->Device );
  DRCIExecuteCommand( CommWindow, work );
  XDDeleteReply( CommWindow );
  DispatchOutput();

  return 0;
}

// Generating variable header. Gets the variables
// generated for the given device and creates the
// variable descriptor table for the postprocessor
// (assembler)
void GenerateVariableHeader( int ProcNum, PtBlock BlockPtr,
			     PtVariable ParentVar )
{
  PtVariable p;
  PtNodeObject	np;
  PtBlock    VarBlock;
  unsigned long Address;
  char	temp[30];

  p = (PtVariable)(BlockPtr->VariableList).Search( ProcNum );
  p = (PtVariable)p->ListHead;
  while( p != NULL )
  {
    np = (PtNodeObject)p->GraphPtr;
    if( np->Auto )	// If compiler created (constant variables are
			// declared by operators
    {
      wsprintf( work2,"Type : %s, ",(LPSTR)np->TypeName );
      if( np->InputNum != NOT_VALID )
		sprintf( temp,"input %u",np->InputNum );
      else
      if( np->OutputNum != NOT_VALID )
		sprintf( temp,"output %u",np->OutputNum );

      strcat( work2,temp );
      if( p->Consumed )
      {
	sprintf( temp,", Cons: %u",p->Consumed );
	strcat( work2,temp );
      }

      sprintf( work1,"\t\t%sNode %u %s\n",remstr,np->NodeNum,work2 );
      Address = p->Address;
      VarBlock = (PtBlock)p->BlockPtr;
// Relocating the variable to the local heap if only
// local variable
      if( !VarBlock->IsRoot )
		Address += ParentVar->Address;
      sprintf( work,"0%lXh",Address );
      sprintf( OutLine ,equstr ,p->ID ,work );
      Mangle( OutLine );
      strcat( OutLine,work1 );
      fputs( OutLine,OutFile );
    }
    p = (PtVariable)p->ForwLink;
  }
}

// Code generator. Called after Schedule() has created
// the activity lists. Translates the activity lists
// into source programs. Returns 0 if OK else
// 1, if output file couldn't be opened
int Codegen()
{
  PtProcessor	PProc,TProc;
  PtActivity	PAct,p1,p2;
  PtVariable	PVar,p;
  PtNodeInfo	ip;
  PtNodeObject	np;
  PtBlock	sbp,bp;
  int		ProcNum,Inpnum,Outnum,i;
  char		temp[30];
  unsigned long	VID,utmp;

  ActBlock = &RootBlock;
  PProc = (PtProcessor)ProcessorList.ListHead;
  SchedFile = fopen( "rcomp.scd","w" );
  DebFile = fopen( "rcomp.deb","w"  );
  ChanFile = fopen( "rcomp.chn","w" );
  while( PProc != NULL )
  {
    ProcNum = PProc->NodeNum;
    PAct = (PtActivity)(ActBlock->ActivityList).Search( ProcNum );
    PVar = (PtVariable)(RootBlock.VariableList).Search( ProcNum );

    wsprintf( work1,"%u.asm",ProcNum );
    if( ( OutFile = fopen( work1,"w" ) ) == NULL )
		return 1;
    UpdateDlgText( MD_COMPTEXT,work1 );
    wsprintf( work,"(banner '%s)\n",(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    sprintf( OutLine,work+1,work1,PVar->Address,PAct->STime );
    Mangle( OutLine );
    fputs( OutLine,OutFile );
    if( PAct->STime == 0L )
    {
      sprintf( work1,"No activity on proc#%u",ProcNum );
      WarningMessage( work1 );
    }

    wsprintf( work,"(get-equ '%s)\n",(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    strcpy( equstr,work+1 );

    wsprintf( work,"(get-rem '%s)\n",(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    strcpy( remstr,work+1 );

// Sending out first the global variable header
    GenerateVariableHeader( ProcNum,&RootBlock,PVar );
// Then the local variables for each block
    bp = (PtBlock)RootBlock.SubList;
    while( bp != NULL )
    {
      if( (bp->VariableList).SubList != NULL )
      {
	wsprintf( OutLine,"%s Variables for block %s\n",
		      (LPSTR)remstr,
		      (LPSTR)bp->BlockName );
	fputs( OutLine, OutFile );
	GenerateVariableHeader( ProcNum,bp,PVar );
      }
      bp = (PtBlock)bp->BackLink;
    }
    fprintf( OutFile,"\n" );

// Sending out constructor section
    wsprintf( work,"(get-begin-constr '%s)\n",
				(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    Mangle( work+1 );
    fputs( work+1,OutFile );
    ip = (PtNodeInfo)RootBlock.NodeList.ListHead;
    while( ip != NULL )
    {
      if( ( ip->Type == OPTYPE_BLOCK ) )
      {
	bp = ActBlock->SearchBlockName( ip->Operator );
	if( !bp->ConstrGenerated )	// Let's recurse into this block
	{
	  sbp = ActBlock;
	  wsprintf( work,"%s Constructors for block %s\n",
		   (LPSTR)remstr,(LPSTR)bp->BlockName );
	  fputs( work,OutFile );
	  ActBlock = bp;
	  GenerateConstructorSection( PProc, ProcNum );
	  bp->ConstrGenerated = TRUE;
	  ActBlock = sbp;
	}
      }
      ip = (PtNodeInfo)ip->ForwLink;
    }
    wsprintf( work,"%s Constructors for root block\n",
		   (LPSTR)remstr );
    GenerateConstructorSection( PProc, ProcNum );

    wsprintf( work,"(get-end-constr '%s)\n",
			(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    Mangle( work+1 );
    fputs( work+1,OutFile );

// Sending out operator section
    fprintf( OutFile,"\n" );
    wsprintf( work,"(get-begin-op '%s)\n",
			(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    Mangle( work+1 );
    fputs( work+1,OutFile );

    ip = (PtNodeInfo)RootBlock.NodeList.ListHead;
    while( ip != NULL )
    {
      if( ( ip->Type == OPTYPE_BLOCK ) )
      {
	bp = ActBlock->SearchBlockName( ip->Operator );
	if( !bp->OpGenerated )	// Let's recurse into this block
	{
	  sbp = ActBlock;
	  wsprintf( work,"(get-begin-block '%s '%s)\n",
		(LPSTR)PProc->Device,(LPSTR)bp->BlockName );
	  _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
	  XDDeleteReply( CommWindow );
	  DispatchOutput();

	  ActBlock = bp;
	  GenerateOperatorSection( PProc, ProcNum );
	  bp->OpGenerated = TRUE;
	  wsprintf( work,"(get-end-block '%s '%s)\n",
		(LPSTR)PProc->Device,(LPSTR)bp->BlockName );
	  _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
	  XDDeleteReply( CommWindow );
	  DispatchOutput();
	  ActBlock = sbp;
	}
      }
      ip = (PtNodeInfo)ip->ForwLink;
    }

    if( IsDynamic )
	GenerateDynamicScheduler( PProc, PAct );
    else
	GenerateOperatorSection( PProc, ProcNum );

    wsprintf( work,"(get-end-op '%s)\n",
			(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    Mangle( work+1 );
    fputs( work+1,OutFile );

// Destructor section
    fprintf( OutFile,"\n" );
    wsprintf( work,"(get-begin-destr '%s)\n",
				(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    Mangle( work+1 );
    fputs( work+1,OutFile );
    ip = (PtNodeInfo)RootBlock.NodeList.ListHead;
    while( ip != NULL )
    {
      if( ( ip->Type == OPTYPE_BLOCK ) )
      {
	bp = ActBlock->SearchBlockName( ip->Operator );
	if( !bp->DestrGenerated )	// Let's recurse into this block
	{
	  sbp = ActBlock;
	  wsprintf( work,"%s Destructors for block %s\n",
		   (LPSTR)remstr,(LPSTR)bp->BlockName );
	  fputs( work,OutFile );
	  ActBlock = bp;
	  GenerateDestructorSection( PProc, ProcNum );
	  bp->DestrGenerated = TRUE;
	  ActBlock = sbp;
	}
      }
      ip = (PtNodeInfo)ip->ForwLink;
    }
    wsprintf( work,"%s Destructors for root block\n",
		   (LPSTR)remstr );
    GenerateDestructorSection( PProc, ProcNum );

    wsprintf( work,"(get-end-destr '%s)\n",
			(LPSTR)PProc->Device );
    _fstrcpy( work,DRCIExecuteCommand( CommWindow, work ) );
    XDDeleteReply( CommWindow );
    work[strlen(work)-3]=0;	// Cutting closing ",\r,\n
    Mangle( work+1 );
    fputs( work+1,OutFile );

    fclose( OutFile );
    PProc = (PtProcessor)PProc->ForwLink;
  }
  fclose( SchedFile );
  fclose( DebFile );
  fclose( ChanFile );
  return 0;
}
